/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.*;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * Dataset
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class Dataset {
  @JsonProperty("acronym")
  private String acronym = null;

  @JsonProperty("archived")
  private LocalDateTime archived = null;

  @JsonProperty("badges")
  private List<Badge> badges = null;

  @JsonProperty("community_resources")
  private List<Object> communityResources = null;

  @JsonProperty("created_at")
  private LocalDateTime createdAt = null;

  @JsonProperty("deleted")
  private LocalDateTime deleted = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("extras")
  private Object extras = null;

  @JsonProperty("featured")
  private Boolean featured = null;

  /**
   * The update frequency
   */
  public enum FrequencyEnum {
    UNKNOWN("unknown"),
    
    PUNCTUAL("punctual"),
    
    CONTINUOUS("continuous"),
    
    HOURLY("hourly"),
    
    FOURTIMESADAY("fourTimesADay"),
    
    THREETIMESADAY("threeTimesADay"),
    
    SEMIDAILY("semidaily"),
    
    DAILY("daily"),
    
    FOURTIMESAWEEK("fourTimesAWeek"),
    
    THREETIMESAWEEK("threeTimesAWeek"),
    
    SEMIWEEKLY("semiweekly"),
    
    WEEKLY("weekly"),
    
    BIWEEKLY("biweekly"),
    
    THREETIMESAMONTH("threeTimesAMonth"),
    
    SEMIMONTHLY("semimonthly"),
    
    MONTHLY("monthly"),
    
    BIMONTHLY("bimonthly"),
    
    QUARTERLY("quarterly"),
    
    THREETIMESAYEAR("threeTimesAYear"),
    
    SEMIANNUAL("semiannual"),
    
    ANNUAL("annual"),
    
    BIENNIAL("biennial"),
    
    TRIENNIAL("triennial"),
    
    QUINQUENNIAL("quinquennial"),
    
    IRREGULAR("irregular");

    private String value;

    FrequencyEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static FrequencyEnum fromValue(String text) {
      for (FrequencyEnum b : FrequencyEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("frequency")
  private FrequencyEnum frequency = FrequencyEnum.UNKNOWN;

  @JsonProperty("frequency_date")
  private LocalDateTime frequencyDate = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("last_modified")
  private LocalDateTime lastModified = null;

  @JsonProperty("last_update")
  private LocalDateTime lastUpdate = null;

  @JsonProperty("license")
  private String license = "notspecified";

  @JsonProperty("metrics")
  private Object metrics = null;

  @JsonProperty("organization")
  private Organization organization = null;

  @JsonProperty("owner")
  private Object owner = null;

  @JsonProperty("page")
  private String page = null;

  @JsonProperty("private")
  private Boolean _private = null;

  @JsonProperty("quality")
  private Object quality = null;

  @JsonProperty("resources")
  private List<Resource> resources = null;

  @JsonProperty("slug")
  private String slug = null;

  @JsonProperty("spatial")
  private Object spatial = null;

  @JsonProperty("tags")
  private List<String> tags = null;

  @JsonProperty("temporal_coverage")
  private Object temporalCoverage = null;

  @JsonProperty("title")
  private String title = null;

  @JsonProperty("uri")
  private String uri = null;

  public Dataset acronym(String acronym) {
    this.acronym = acronym;
    return this;
  }

   /**
   * An optional dataset acronym
   * @return acronym
  **/
  @ApiModelProperty(value = "An optional dataset acronym")
  public String getAcronym() {
    return acronym;
  }

  public void setAcronym(String acronym) {
    this.acronym = acronym;
  }

  public Dataset archived(LocalDateTime archived) {
    this.archived = archived;
    return this;
  }

   /**
   * The archival date if archived
   * @return archived
  **/
  @ApiModelProperty(value = "The archival date if archived")
  public LocalDateTime getArchived() {
    return archived;
  }

  public void setArchived(LocalDateTime archived) {
    this.archived = archived;
  }

   /**
   * The dataset badges
   * @return badges
  **/
  @ApiModelProperty(value = "The dataset badges")
  public List<Badge> getBadges() {
    return badges;
  }

  public Dataset communityResources(List<Object> communityResources) {
    this.communityResources = communityResources;
    return this;
  }

  public Dataset addCommunityResourcesItem(Object communityResourcesItem) {
    if (this.communityResources == null) {
      this.communityResources = new ArrayList<Object>();
    }
    this.communityResources.add(communityResourcesItem);
    return this;
  }

   /**
   * Get communityResources
   * @return communityResources
  **/
  @ApiModelProperty(value = "")
  public List<Object> getCommunityResources() {
    return communityResources;
  }

  public void setCommunityResources(List<Object> communityResources) {
    this.communityResources = communityResources;
  }

  public Dataset createdAt(LocalDateTime createdAt) {
    this.createdAt = createdAt;
    return this;
  }

   /**
   * The dataset creation date
   * @return createdAt
  **/
  @ApiModelProperty(required = true, value = "The dataset creation date")
  public LocalDateTime getCreatedAt() {
    return createdAt;
  }

  public void setCreatedAt(LocalDateTime createdAt) {
    this.createdAt = createdAt;
  }

  public Dataset deleted(LocalDateTime deleted) {
    this.deleted = deleted;
    return this;
  }

   /**
   * The deletion date if deleted
   * @return deleted
  **/
  @ApiModelProperty(value = "The deletion date if deleted")
  public LocalDateTime getDeleted() {
    return deleted;
  }

  public void setDeleted(LocalDateTime deleted) {
    this.deleted = deleted;
  }

  public Dataset description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The dataset description in markdown
   * @return description
  **/
  @ApiModelProperty(required = true, value = "The dataset description in markdown")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Dataset extras(Object extras) {
    this.extras = extras;
    return this;
  }

   /**
   * Extras attributes as key-value pairs
   * @return extras
  **/
  @ApiModelProperty(value = "Extras attributes as key-value pairs")
  public Object getExtras() {
    return extras;
  }

  public void setExtras(Object extras) {
    this.extras = extras;
  }

  public Dataset featured(Boolean featured) {
    this.featured = featured;
    return this;
  }

   /**
   * Is the dataset featured
   * @return featured
  **/
  @ApiModelProperty(value = "Is the dataset featured")
  public Boolean isFeatured() {
    return featured;
  }

  public void setFeatured(Boolean featured) {
    this.featured = featured;
  }

  public Dataset frequency(FrequencyEnum frequency) {
    this.frequency = frequency;
    return this;
  }

   /**
   * The update frequency
   * @return frequency
  **/
  @ApiModelProperty(example = "unknown", required = true, value = "The update frequency")
  public FrequencyEnum getFrequency() {
    return frequency;
  }

  public void setFrequency(FrequencyEnum frequency) {
    this.frequency = frequency;
  }

  public Dataset frequencyDate(LocalDateTime frequencyDate) {
    this.frequencyDate = frequencyDate;
    return this;
  }

   /**
   * Next expected update date, you will be notified once that date is reached.
   * @return frequencyDate
  **/
  @ApiModelProperty(value = "Next expected update date, you will be notified once that date is reached.")
  public LocalDateTime getFrequencyDate() {
    return frequencyDate;
  }

  public void setFrequencyDate(LocalDateTime frequencyDate) {
    this.frequencyDate = frequencyDate;
  }

   /**
   * The dataset identifier
   * @return id
  **/
  @ApiModelProperty(value = "The dataset identifier")
  public String getId() {
    return id;
  }

  public Dataset lastModified(LocalDateTime lastModified) {
    this.lastModified = lastModified;
    return this;
  }

   /**
   * The dataset last modification date
   * @return lastModified
  **/
  @ApiModelProperty(required = true, value = "The dataset last modification date")
  public LocalDateTime getLastModified() {
    return lastModified;
  }

  public void setLastModified(LocalDateTime lastModified) {
    this.lastModified = lastModified;
  }

  public Dataset lastUpdate(LocalDateTime lastUpdate) {
    this.lastUpdate = lastUpdate;
    return this;
  }

  public void setId(String id) {
    this.id = id;
  }

  /**
   * The resources last modification date
   * @return lastUpdate
  **/
  @ApiModelProperty(required = true, value = "The resources last modification date")
  public LocalDateTime getLastUpdate() {
    return lastUpdate;
  }

  public void setLastUpdate(LocalDateTime lastUpdate) {
    this.lastUpdate = lastUpdate;
  }

  public Dataset license(String license) {
    this.license = license;
    return this;
  }

   /**
   * The dataset license
   * @return license
  **/
  @ApiModelProperty(value = "The dataset license")
  public String getLicense() {
    return license;
  }

  public void setLicense(String license) {
    this.license = license;
  }

  public Dataset metrics(Object metrics) {
    this.metrics = metrics;
    return this;
  }

   /**
   * The dataset metrics
   * @return metrics
  **/
  @ApiModelProperty(value = "The dataset metrics")
  public Object getMetrics() {
    return metrics;
  }

  public void setMetrics(Object metrics) {
    this.metrics = metrics;
  }

  public Dataset organization(Organization organization) {
    this.organization = organization;
    return this;
  }

   /**
   * The producer organization
   * @return organization
  **/
  @ApiModelProperty(value = "The producer organization")
  public Organization getOrganization() {
    return organization;
  }

  public void setOrganization(Organization organization) {
    this.organization = organization;
  }

  public Dataset owner(Object owner) {
    this.owner = owner;
    return this;
  }

   /**
   * The user information
   * @return owner
  **/
  @ApiModelProperty(value = "The user information")
  public Object getOwner() {
    return owner;
  }

  public void setOwner(Object owner) {
    this.owner = owner;
  }

  public Dataset page(String page) {
    this.page = page;
    return this;
  }

   /**
   * The dataset page URL
   * @return page
  **/
  @ApiModelProperty(required = true, value = "The dataset page URL")
  public String getPage() {
    return page;
  }

  public void setPage(String page) {
    this.page = page;
  }

  public Dataset _private(Boolean _private) {
    this._private = _private;
    return this;
  }

   /**
   * Is the dataset private to the owner or the organization
   * @return _private
  **/
  @ApiModelProperty(value = "Is the dataset private to the owner or the organization")
  public Boolean isPrivate() {
    return _private;
  }

  public void setPrivate(Boolean _private) {
    this._private = _private;
  }

   /**
   * The dataset quality
   * @return quality
  **/
  @ApiModelProperty(value = "The dataset quality")
  public Object getQuality() {
    return quality;
  }

  public Dataset resources(List<Resource> resources) {
    this.resources = resources;
    return this;
  }

  public Dataset addResourcesItem(Resource resourcesItem) {
    if (this.resources == null) {
      this.resources = new ArrayList<Resource>();
    }
    this.resources.add(resourcesItem);
    return this;
  }

   /**
   * Get resources
   * @return resources
  **/
  @ApiModelProperty(value = "")
  public List<Resource> getResources() {
    return resources;
  }

  public void setResources(List<Resource> resources) {
    this.resources = resources;
  }

  public Dataset slug(String slug) {
    this.slug = slug;
    return this;
  }

   /**
   * The dataset permalink string
   * @return slug
  **/
  @ApiModelProperty(required = true, value = "The dataset permalink string")
  public String getSlug() {
    return slug;
  }

  public void setSlug(String slug) {
    this.slug = slug;
  }

  public Dataset spatial(Object spatial) {
    this.spatial = spatial;
    return this;
  }

   /**
   * The spatial coverage
   * @return spatial
  **/
  @ApiModelProperty(value = "The spatial coverage")
  public Object getSpatial() {
    return spatial;
  }

  public void setSpatial(Object spatial) {
    this.spatial = spatial;
  }

  public Dataset tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public Dataset addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Get tags
   * @return tags
  **/
  @ApiModelProperty(value = "")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public Dataset temporalCoverage(Object temporalCoverage) {
    this.temporalCoverage = temporalCoverage;
    return this;
  }

   /**
   * The temporal coverage
   * @return temporalCoverage
  **/
  @ApiModelProperty(value = "The temporal coverage")
  public Object getTemporalCoverage() {
    return temporalCoverage;
  }

  public void setTemporalCoverage(Object temporalCoverage) {
    this.temporalCoverage = temporalCoverage;
  }

  public Dataset title(String title) {
    this.title = title;
    return this;
  }

   /**
   * The dataset title
   * @return title
  **/
  @ApiModelProperty(required = true, value = "The dataset title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public Dataset uri(String uri) {
    this.uri = uri;
    return this;
  }

   /**
   * The dataset API URI
   * @return uri
  **/
  @ApiModelProperty(required = true, value = "The dataset API URI")
  public String getUri() {
    return uri;
  }

  public void setUri(String uri) {
    this.uri = uri;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Dataset dataset = (Dataset) o;
    return Objects.equals(this.acronym, dataset.acronym) &&
        Objects.equals(this.archived, dataset.archived) &&
        Objects.equals(this.badges, dataset.badges) &&
        Objects.equals(this.communityResources, dataset.communityResources) &&
        Objects.equals(this.createdAt, dataset.createdAt) &&
        Objects.equals(this.deleted, dataset.deleted) &&
        Objects.equals(this.description, dataset.description) &&
        Objects.equals(this.extras, dataset.extras) &&
        Objects.equals(this.featured, dataset.featured) &&
        Objects.equals(this.frequency, dataset.frequency) &&
        Objects.equals(this.frequencyDate, dataset.frequencyDate) &&
        Objects.equals(this.id, dataset.id) &&
        Objects.equals(this.lastModified, dataset.lastModified) &&
        Objects.equals(this.lastUpdate, dataset.lastUpdate) &&
        Objects.equals(this.license, dataset.license) &&
        Objects.equals(this.metrics, dataset.metrics) &&
        Objects.equals(this.organization, dataset.organization) &&
        Objects.equals(this.owner, dataset.owner) &&
        Objects.equals(this.page, dataset.page) &&
        Objects.equals(this._private, dataset._private) &&
        Objects.equals(this.quality, dataset.quality) &&
        Objects.equals(this.resources, dataset.resources) &&
        Objects.equals(this.slug, dataset.slug) &&
        Objects.equals(this.spatial, dataset.spatial) &&
        Objects.equals(this.tags, dataset.tags) &&
        Objects.equals(this.temporalCoverage, dataset.temporalCoverage) &&
        Objects.equals(this.title, dataset.title) &&
        Objects.equals(this.uri, dataset.uri);
  }

  @Override
  public int hashCode() {
    return Objects.hash(acronym, archived, badges, communityResources, createdAt, deleted, description, extras, featured, frequency, frequencyDate, id, lastModified, lastUpdate, license, metrics, organization, owner, page, _private, quality, resources, slug, spatial, tags, temporalCoverage, title, uri);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Dataset {\n");

    sb.append("    acronym: ").append(toIndentedString(acronym)).append("\n");
    sb.append("    archived: ").append(toIndentedString(archived)).append("\n");
    sb.append("    badges: ").append(toIndentedString(badges)).append("\n");
    sb.append("    communityResources: ").append(toIndentedString(communityResources)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    deleted: ").append(toIndentedString(deleted)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    extras: ").append(toIndentedString(extras)).append("\n");
    sb.append("    featured: ").append(toIndentedString(featured)).append("\n");
    sb.append("    frequency: ").append(toIndentedString(frequency)).append("\n");
    sb.append("    frequencyDate: ").append(toIndentedString(frequencyDate)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("    lastUpdate: ").append(toIndentedString(lastUpdate)).append("\n");
    sb.append("    license: ").append(toIndentedString(license)).append("\n");
    sb.append("    metrics: ").append(toIndentedString(metrics)).append("\n");
    sb.append("    organization: ").append(toIndentedString(organization)).append("\n");
    sb.append("    owner: ").append(toIndentedString(owner)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    _private: ").append(toIndentedString(_private)).append("\n");
    sb.append("    quality: ").append(toIndentedString(quality)).append("\n");
    sb.append("    resources: ").append(toIndentedString(resources)).append("\n");
    sb.append("    slug: ").append(toIndentedString(slug)).append("\n");
    sb.append("    spatial: ").append(toIndentedString(spatial)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    temporalCoverage: ").append(toIndentedString(temporalCoverage)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    uri: ").append(toIndentedString(uri)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

